//  Leonard Bencloski (lmb92@pitt.edu)
//  Assignment #2
//  CS1520
//
//  Black Jack

// This class is called by assign2 and is used to connect to the server.

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.util.*;

import java.net.*;
import java.io.*;

public class Connect
{
	Socket server;
	ObjectOutputStream out;
	ObjectInputStream in;
	public short score=0;
	public short dealer=0;
	public short outcome=0;
	public Deck tt;
	public Card temp;
	public Card temp2;
	public playerStand standObj;
	public boolean connected = false;

	public ArrayList cCards = new ArrayList();
	public ArrayList sCards = new ArrayList();


	public int PORT = 5678;
	public String addr = "";
	InetAddress address;

	public Connect(InetAddress ad, String serName)
	{

		address = ad;
		addr = "";
		addr = serName;

	try {
		  server = new Socket( address, PORT );
		  out = new ObjectOutputStream( server.getOutputStream(  ) );
		  in = new ObjectInputStream( server.getInputStream(  ) );

		  connected = true;

		}
		catch ( IOException e )
		{
		  System.out.println( "I/O error " + e ); // I/O error
		}


	}

	// Used when a player requests a hit.  Asks the server for a new card, then reads it in
	// and saves it into an array list.
	public short operation()
	{
		try
		{
			out.writeObject( new newCard(  ) );
			out.flush(  );
			temp = (Card) in.readObject();

			 if( temp instanceof Card )
			 {
				cCards.add(temp);
			 }
			dealerResult rslt = (dealerResult) in.readObject();

			if( rslt instanceof dealerResult )
			{
				score = rslt.score;
				outcome = rslt.x;
			}

		}//TRY
		catch ( IOException e )
		{
		  System.out.println( "I/O error " + e ); // I/O error
		}
		catch ( ClassNotFoundException e2 )
		{
		  System.out.println( e2 ); // unknown type of response object
		}

		return outcome;
	}

	// Sends a message to disconnect from server.
	public void disconnect()
	{
		try
		{

			out.writeObject( new Close(  ) );
			out.flush(  );
			score = 0;
			cCards.clear();
			sCards.clear();
			}
			catch ( IOException e )
			{
			  System.out.println( "I/O error " + e ); // I/O error
			}
		}

	// Sends a message to start a new hand.  Checks for a blackjack.
	public short nwHand()
	{
		Card ncd;
		Card ncd2;
		dealerResult res;
		short rlt = 0;
		dealer = 0;
		score = 0;
		cCards.clear();
		sCards.clear();

		try
		{

			out.writeObject( new newHand(  ) );
			out.flush(  );
			Object tempObj2 = in.readObject();

			if( tempObj2 instanceof dealerCard ) // If dealer card, add to dealer list.
			{
				for(int s=0; s<2; s++)
				{
					tempObj2 = in.readObject();
					ncd2 = (Card) tempObj2;
					sCards.add(ncd2);
				}

			}

			tempObj2 = in.readObject();
			if( tempObj2 instanceof clientCard ) // If player card, add to player list.
			{
				for(int s=0; s<2; s++)
				{
					tempObj2 = in.readObject();
					ncd2 = (Card) tempObj2;
					cCards.add(ncd2);
				}

			}

			Object tempObj3 = in.readObject();
			if( tempObj3 instanceof dealerResult ) // Gets the result of a hand, tests for Blackjack.
			{
				res = (dealerResult) tempObj3;
				rlt = res.x;
				score = res.score;
				dealer = res.dealer;
			}


			}//End try
			catch ( IOException e )
			{
			  System.out.println( "I/O error " + e ); // I/O error
			}
			catch ( ClassNotFoundException e2 )
			{
			  System.out.println( e2 ); // unknown type of response object
			}

			return rlt;  // returns result.
	}

	// Sends a message that a player Stands.  Then gets dealer cards.
	public short stand()
	{
		int cardCount=0;
		try
		{
			out.writeObject( new playerStand(  ) );
			out.flush(  );
			standObj = (playerStand) in.readObject();
			 if( standObj instanceof playerStand )
			 {
				cardCount = standObj.count;
				outcome = standObj.x;
				dealer = standObj.dealer;
			}

			send sent = (send) in.readObject();  // Checks if there are cards to send.

			if(sent.ok)
			{
				Card dealCards = (Card) in.readObject();
				if( dealCards instanceof Card )
				{
					sCards.add(dealCards);
					cardCount--;

					for(int e=0; e<cardCount; e++)
					{
						dealCards = (Card) in.readObject();
						sCards.add(dealCards);
					}

				}
			}

		}//TRY
		catch ( IOException e )
		{
		  System.out.println( "I/O error " + e ); // I/O error
		}
		catch ( ClassNotFoundException e2 )
		{
		  System.out.println( e2 ); // unknown type of response object
		}

			return outcome;

	}

} //End