//  Leonard Bencloski (lmb92@pitt.edu)
//  Assignment #2
//  CS1520
//
//  Black Jack

//  First connect to the server, then click "Start New Hand" to play.

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.util.*;

import java.net.*;
import java.io.*;

public class assign2 extends JFrame implements ActionListener, Runnable
{

	Color col;

	// Different colors used to paint the background and fonts.
	Color col2 = new Color(34, 96, 23);
	Color col3 = new Color(223, 99, 44);
	Color col4 = new Color(248, 224, 134);

	Container c;

    // Used to connect to the server.
	Connect link;

	// Setting up the GUI items.
	JButton hit, stand, newHand, connect;
	JLabel label1;
	Deck tt;

	JPanel gui;
	DrawPanel drawing;

	int graf = 0;
	boolean hitP = false;
	boolean moving = true;
	boolean dealerP = false;
	boolean firstP = false;
	boolean standP = false;

	boolean playerWin = false;
	boolean dealerWin = false;
	boolean tie = false;
	int delay = 30;

	int moveCard = 0;
	int moveCard2 = 0;
	boolean starter = true;
	int wait = 0;
	int imtrack = 0;


	Toolkit toolkit = Toolkit.getDefaultToolkit();
	ArrayList cardImg = new ArrayList();
	ArrayList cardImg2 = new ArrayList();


	private ArrayList player;
	private ArrayList dealer;

	Font font = new Font("Arial", Font.PLAIN, 24);
	Font font2 = new Font("Arial", Font.BOLD, 26);

	  public assign2()
	  {


			super("Leonard Bencloski (lmb92@pitt.edu) - Assignment 2 (BlackJack) - CS1520");

			Thread refresher = new Thread(this);
   			 refresher.start();

			//tracker = new MediaTracker(this);

            // Set up the GUI
			newHand = new JButton("Start New Hand");
			newHand.setBackground(col4);
			hit = new JButton("Hit");
			hit.setBackground(col4);
			stand = new JButton("Stand");
			stand.setBackground(col4);
			connect = new JButton("Connect");
			connect.setBackground(col4);
			label1 = new JLabel("");

			gui = new JPanel();
			gui.setLayout(new GridLayout(2,3));
			gui.setBackground(Color.white);

			gui.add(newHand);
			gui.add(hit);
			gui.add(stand);
			gui.add(connect);
			gui.add(label1);

			Dimension pdim = gui.getSize();
			Dimension fdim = this.getSize();

			drawing = new DrawPanel((int) fdim.getWidth(), (int) (fdim.getHeight()-pdim.getHeight()));

			drawing.setBackground(col2);

			c = getContentPane();
			c.setLayout(new BorderLayout());
			c.add(gui, BorderLayout.SOUTH);
			c.add(drawing, BorderLayout.CENTER);

			newHand.addActionListener(this);
			hit.addActionListener(this);
			stand.addActionListener(this);
			connect.addActionListener(this);

			connect.setEnabled(true);
			newHand.setEnabled(false);
			hit.setEnabled(false);
			stand.setEnabled(false);

			label1.setText(" Click Connect to begin playing. ");

			setSize(740,420);
			show();
			}

		// Detect which buttons has been clicked.
		public void actionPerformed (ActionEvent e)
		{
			// If it's a hit, get a card and determine if the Player won, lost
			// or if the game should continue.
			if (e.getSource() == hit)
			{

				wait=0;
				short outcome = link.operation();  // Checks the outcome, sent from server.
				player = link.cCards;
				cardImg.clear();
			    moveCard = 0;

				hitP = true;
				graf = 1;  // Enables cards to be painted.
				repaint();

				if(outcome==0)
				{
					label1.setText(" Player wins with a score of: "+ link.score);
					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
					dealerP=true;
					playerWin=true;
				}
				else if(outcome==1)
				{
					label1.setText(" Dealer wins with a score of: "+ link.dealer);
					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
					dealerP=true;
					dealerWin=true;
				}
				else if(outcome==2)
				{
					label1.setText(" Push! Tie Score: "+ link.score);
					tie=true;
				}
				else if(outcome==3)
					label1.setText(" Player Score: " + link.score);

			}
			// New Hand. Starts a new game.  Gets cards from server and checks for a
			// blackjack.  If not, game continues.
			else if (e.getSource() == newHand)
			{
				//repaint();
				short res = link.nwHand();

				dealer = link.sCards;  // These get the list of cards from the server.
				player = link.cCards;


				moveCard = 0; // Used for animation.
				moveCard2 = 0;

				wait=0;
				dealerWin = false;
				playerWin = false;
				tie = false;
				hitP = false;

				firstP = true; // Determines how and which cards are moved and displayed.
				moving = true;
				dealerP = false;
				cardImg.clear();
				cardImg2.clear();

				newHand.setEnabled(false);
				stand.setEnabled(true);
				hit.setEnabled(true);

				graf = 1;
				repaint();


				if(res==0)
				{
					label1.setText(" Player wins with a BlackJack! ");
					newHand.setEnabled(true);
					stand.setEnabled(false);
					hit.setEnabled(false);
					dealerP=true;
					playerWin=true;
				}
				else if(res==1)
				{
					label1.setText(" Dealer wins with a BlackJack! ");
					newHand.setEnabled(true);
					stand.setEnabled(false);
					hit.setEnabled(false);
					dealerP=true;
					dealerWin=true;
				}
				else if(res==2)
				{
					label1.setText(" Push. Tie Score. ");
					newHand.setEnabled(true);
					stand.setEnabled(false);
					hit.setEnabled(false);
					dealerP=true;
					tie = true;
				}
				else if(res==3)
					label1.setText(" Player Score: " + link.score );

			}

			// Checks if the player stands.  Then gets the dealer cards and checks the outcome
			// to determine the winner.
			else if (e.getSource() == stand)
			{

				short out = link.stand(); // Outcome of the game. 0=player wins, 1=dealer, 2=push
				dealer = link.sCards;
				player = link.cCards;
				wait=0;
				stand.setEnabled(false);
			    cardImg2.clear();
				dealerP=true;
				graf = 1;
				repaint();

				if(out==0)
				{
					label1.setText(" Player wins with a score of: "+ link.score);
					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
					playerWin=true;
				}
				else if(out==1)
				{

					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
					label1.setText(" Dealer wins with a score of: "+ link.dealer);
					dealerWin=true;
				}
				else if(out==2)
				{
					label1.setText(" Push! Tie Score: "+ link.dealer);
					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
					tie = true;
				}
				else if(out==3)
				{
					label1.setText("  ");
					newHand.setEnabled(true);
					hit.setEnabled(false);
					stand.setEnabled(false);
				}


			}

			// Connects to server by starting a "Connect" class that links to the server.
			// Also checks to make sure the connection is valid and running.
			// If not, display a message and let the user try again.
			else if (e.getSource() == connect)
			{
				label1.setText("");
				if(connect.getText().equals("Connect"))
				{
					String serverName = null;
					serverName = JOptionPane.showInputDialog(this, "Enter the server name:", "localhost");
					if(serverName != null)
						try
						{
							InetAddress addr = InetAddress.getByName(serverName);
							link = new Connect(addr, serverName);

							if(link != null)
							{
								if(link.connected == true)
								{
									connect.setText("Disconnect");
									label1.setText(" Connected: " + link.addr);
									newHand.setEnabled(true);
								}
								else
								{
									label1.setText(" Failed reaching: " + serverName);
								}
							}
							else
							{
								label1.setText(" Failed reaching: " + serverName);
							}


						}
						catch(Exception e0)
						{
							System.out.println(e0);
						}
				}
				else
				{
					link.disconnect();
					connect.setText("Connect");
					label1.setText(" Click Connect to begin playing.");
					hit.setEnabled(false);
					stand.setEnabled(false);
					newHand.setEnabled(false);
					graf = 0;
					//connect.setBackground(col4);
					playerWin=false;
					dealerWin=false;
					tie=false;
				}

			}
}


  private class DrawPanel extends JPanel
   {
 	  private int prefwid, prefht;

        public DrawPanel(int pwid, int pht)
        {

            prefwid = pwid;
            prefht = pht;
		}

	//
	public void paintComponent (Graphics g)
	{
			// These are used to display cards across the screen.
			int mover = 90;
			int starter = 25;
			int mover2 = 90;
			int starter2 = 25;
			int starter3 = 25;
			Card readIt;
			String builder="";

			super.paintComponent(g);

			Graphics2D g2d = (Graphics2D) g;

			// Turns on Antialiasing to smooth out the images.
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

			int zr = 0;
			int zr2= 0;

			int mvc = 0;
			int mvc2 = 0;

			// Sets up the fonts so we can display text to the user.
			g2d.setFont(font);
			g2d.setPaint(Color.white);
			g2d.drawString("Dealer:",25,35);
			g2d.drawString("Player:",25,200);

			Shape r = new Rectangle2D.Double (15,214,650,110);
			g2d.setPaint(new GradientPaint(40,40, Color.lightGray,60,50,Color.white,true));
			g2d.draw(r);

			if( graf == 1 )
			{

				player = link.cCards;
				dealer = link.sCards;

				// Sets up the text if not a first play (new hand event) or a player hit even.
				if(!firstP && !hitP)
				{
					g2d.setFont(font);
					g2d.setPaint(Color.white);
					g2d.drawString(""+link.score,108,200);
				}

				zr = player.size();
				zr2 = dealer.size();


				// Build an arraylist of the Player Cards.
				for(int b=0; b<player.size(); b++)
				{
					readIt = (Card) player.get(b);
					if(readIt.isLetter == true)
					{
						builder = "" + readIt.first + readIt.second + ".gif";
					}
					else
					{
						builder = "" + readIt.value + readIt.first + ".gif";
					}

					// Image icon used to make sure image is done loading.
					// Otherwise, animations can be choppy since the image isn't done
					// loading.
					ImageIcon img = new ImageIcon(builder);
   					Image test = img.getImage();
					cardImg.add(test);


				}

				// Builds an arraylist of the dealer cards.
				for(int a=0; a<dealer.size(); a++)
				{
					readIt = (Card) dealer.get(a);
					if(readIt.isLetter == true)
					{
						builder = "" + readIt.first + readIt.second + ".gif";
					}
					else
					{
						builder = "" + readIt.value + readIt.first + ".gif";
					}

					ImageIcon img = new ImageIcon(builder);
   					Image test = img.getImage();
					cardImg2.add(test);

				}

			}

			// Moves the dealers cards on a New Hand event.
			if(zr2>0 && moving)
			{
				g2d.drawImage((Image)cardImg2.get(0), starter, moveCard2, this);
				if(!dealerWin)
				{
					ImageIcon img = new ImageIcon("back.gif");
   					Image test = img.getImage();
					g2d.drawImage(test, starter+90, moveCard2, this);
				}
				else
					g2d.drawImage((Image)cardImg2.get(1), starter+90, moveCard2, this);

			}

			// Draws dealer cards after the New Hand event, but before a stand.
			if(zr2>0 && !moving)
			{

				g2d.drawImage((Image)cardImg2.get(0), starter, 55, this);
				if(!dealerWin)
				{
					ImageIcon img = new ImageIcon("back.gif");
   					Image test = img.getImage();
					g2d.drawImage(test, starter+90, 55, this);
				}
				else
					g2d.drawImage((Image)cardImg2.get(1), starter+90, 55, this);


			}

			// Draws a dealers cards after a Stand event.
			if(zr2>0 && dealerP && !moving)
			{

				for(int i = 0; i < zr2; i++)
				{

					g2d.drawImage((Image)cardImg2.get(i), starter, 55, this);
					starter += mover;

				}


			}

			if(zr>0)  // Player cards greater than zero.
			{
				// Draws a players card on a Hit event.
				if(hitP)
				{

					g2d.drawImage((Image)cardImg.get(zr-1), ((mover2*zr)-65), moveCard, this);
					if(moveCard>=220)
						hitP=false;

				}

				// Draws a players card on a New Hand event.
				if(firstP)
				{

						g2d.drawImage((Image)cardImg.get(0), starter2, moveCard, this);
						g2d.drawImage((Image)cardImg.get(1), starter2+90, moveCard, this);

				}

				// Draws a players card after it has stop moving on a Hit event.
				if(!firstP && hitP)
				{
					for(int j = 0; j < zr-1; j++)
					{


						g2d.drawImage((Image)cardImg.get(j), starter2, 220, this);
						starter2 += mover2;

					}
				}

				// Draws a players card after a Stand event.
				if(!firstP && !hitP)
				{
					for(int j = 0; j < zr; j++)
					{
						g2d.drawImage((Image)cardImg.get(j), starter2, 220, this);
						starter2 += mover2;

					 }
				}

			}

				// Displays the results of a hand on the screen.
				if(playerWin && !hitP && !firstP)
				{
					g2d.setFont(font2);
					g2d.setPaint(col3);
					g2d.drawString("You Win!",163,200);
					g2d.setFont(font);
					g2d.setPaint(Color.white);
					g2d.drawString(""+link.dealer,112,35);
				}

				if(dealerWin && !hitP && !firstP)
				{
					g2d.setFont(font2);
					g2d.setPaint(col3);
					g2d.drawString("Dealer Wins!",163,35);
					g2d.setFont(font);
					g2d.setPaint(Color.white);
					g2d.drawString(""+link.dealer,112,35);
				}

				if(tie && !hitP && !firstP)
				{
					g2d.setFont(font2);
					g2d.setPaint(col3);
					g2d.drawString("Push!",163,200);
					g2d.drawString("Push!",163,35);
					g2d.setFont(font);
					g2d.setPaint(Color.white);
					g2d.drawString(""+link.dealer,112,35);

				}


		}
}


     public void run()
     {

		while (true)
       	{
			try
			{
				// This thread constantly repaints the screen.  Used for
				// moving the cards on screen.
				repaint();
				Thread.sleep(30);

					if(moveCard < 220)  // These move the cards
						moveCard += 44;
					else
						firstP=false;

					if(moveCard2 < 55)
						moveCard2 += 11;
					else
						moving=false;


             }
             catch (InterruptedException e) {}

    	}
     }


	// Main.  Starts the program.
	public static void main(String [] args)
	{
		assign2 win = new assign2();


		win.addWindowListener(
			new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
				{ System.exit(0);  }
			}
		   );
	}


}




//}//End program